motters 8 years ago
commit
1954151d9f
69 changed files with 13670 additions and 0 deletions
  1. 619 0
      LICENSE
  2. 22 0
      Makefile
  3. 580 0
      README
  4. 23 0
      debian.sh
  5. 52 0
      debian/changelog
  6. 1 0
      debian/compat
  7. 26 0
      debian/control
  8. 26 0
      debian/copyright
  9. 1 0
      debian/docs
  10. 1 0
      debian/files
  11. 60 0
      debian/rules
  12. 1 0
      debian/source/format
  13. 4 0
      debian/source/include-binaries
  14. 1 0
      edit.sh
  15. 45 0
      fedora.sh
  16. BIN
      img/logo14.png
  17. BIN
      img/logo192.png
  18. BIN
      img/logo64.png
  19. BIN
      man/fin.1.gz
  20. 1 0
      rpmpackage/fin.conf
  21. 58 0
      rpmpackage/fin.spec
  22. 24 0
      src/calendar.c
  23. 27 0
      src/calendar.h
  24. 394 0
      src/conversions.c
  25. 48 0
      src/conversions.h
  26. 1804 0
      src/database.c
  27. 152 0
      src/database.h
  28. 178 0
      src/edit.c
  29. 34 0
      src/edit.h
  30. 75 0
      src/globals.h
  31. 64 0
      src/help.c
  32. 27 0
      src/help.h
  33. 896 0
      src/import.c
  34. 27 0
      src/import.h
  35. 648 0
      src/international.c
  36. 409 0
      src/international.h
  37. 74 0
      src/lock.c
  38. 27 0
      src/lock.h
  39. 872 0
      src/main.c
  40. 343 0
      src/monthly.c
  41. 33 0
      src/monthly.h
  42. 314 0
      src/narrator.c
  43. 34 0
      src/narrator.h
  44. 1279 0
      src/parse.c
  45. 140 0
      src/parse.h
  46. 345 0
      src/piechart.c
  47. 48 0
      src/piechart.h
  48. 360 0
      src/plot.c
  49. 53 0
      src/plot.h
  50. 56 0
      src/receive.c
  51. 38 0
      src/receive.h
  52. 668 0
      src/search.c
  53. 43 0
      src/search.h
  54. 237 0
      src/settings.c
  55. 44 0
      src/settings.h
  56. 55 0
      src/spend.c
  57. 38 0
      src/spend.h
  58. 698 0
      src/summary.c
  59. 37 0
      src/summary.h
  60. 571 0
      src/tests.c
  61. 36 0
      src/tests.h
  62. 106 0
      src/transfer.c
  63. 32 0
      src/transfer.h
  64. 98 0
      src/undo.c
  65. 28 0
      src/undo.h
  66. 215 0
      src/validation.c
  67. 33 0
      src/validation.h
  68. 356 0
      src/yearly.c
  69. 31 0
      src/yearly.h

+ 619 - 0
LICENSE

@@ -0,0 +1,619 @@
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.

+ 22 - 0
Makefile

@@ -0,0 +1,22 @@
+APP=fin
+VERSION=1.42
+
+all:
+	gcc -Wall -ansi -pedantic -O3 -o $(APP) src/*.c -Isrc -lsqlite3
+ 
+debug:
+	gcc -Wall -ansi -pedantic -g -o $(APP) src/*.c -Isrc -lsqlite3
+
+source:
+	tar -cvzf ../$(APP)_$(VERSION).orig.tar.gz ../$(APP)-$(VERSION)
+
+install:
+	cp $(APP) /usr/bin
+	cp man/$(APP).1.gz /usr/share/man/man1
+	chmod 755 /usr/bin/$(APP)
+	chmod 644 /usr/share/man/man1/$(APP).1.gz
+
+clean:
+	rm -f $(APP) \#* \.#* gnuplot* *.png
+	rm -rf deb.* debian/$(APP)
+	rm -f ../$(APP)*.deb ../$(APP)*.changes ../$(APP)*.asc ../$(APP)*.dsc

+ 580 - 0
README

@@ -0,0 +1,580 @@
+*FIN: The command line personal finances manager*
+
+Keeping track of personal finances is an incredibly boring task, and if you don't have much money then juggling it can be tricky.  When looking at the existing software out there to manage accounts it's frequently highly complex and top heavy.  Fin - an abbreviation of "financials" - is an attempt to do the opposite of what most accounting software does, and that's to make things incredibly simple and quick.  Logging a transaction or viewing your current balance should take no more than a few seconds.  This means less time wasted on bureaucracy and more time spent on what you really want to be doing.
+
+* _Installation_
+
+The easiest way to install is via a pre-compiled package.  You can also compile from source as follows:
+
+#+BEGIN_SRC sh
+    sudo apt-get install libsqlite3-dev bcrypt gnuplot
+    make
+    sudo make install
+#+END_SRC
+
+You will need to have the sqlite3 development package installed to be able to compile, and to get the full functionality you'll also need to have gnuplot and bcrypt installed.
+
+
+* _Language_
+
+First set the language:
+
+#+BEGIN_SRC sh
+   fin language "English US"
+
+   fin language "English UK"
+#+END_SRC
+
+Possible languages are: English UK, English US, French, German, Italian, Spanish, Greek, Russian, Polish, Dutch, Chinese
+
+Currently only English UK and English US are implemented.  For translation text see international.c
+
+
+* _Basic Usage_
+
+To log an amount of money spent:
+
+#+BEGIN_SRC sh
+   fin spend <amount> on <thing purchased>
+
+   fin spend 2.99 on cheese
+
+   fin spend 4.50 date 02/07/2011 on bread
+#+END_SRC
+
+Currency symbols such as $ or £ should not be included in the amount.
+
+You might also wish to log where money was spent, so that you can use that as a search criteria later.
+
+#+BEGIN_SRC sh
+   fin spend 25.39 on groceries at supermarket
+#+END_SRC
+
+To receive an amount of money:
+
+#+BEGIN_SRC sh
+   fin receive <amount> from <source>
+
+   fin receive 100 from "balance brought forward"
+#+END_SRC
+
+To show recent transactions just type "fin".  The most recent is at the top.  If you want to list more transactions:
+
+#+BEGIN_SRC sh
+   fin transactions <number>
+#+END_SRC
+
+You can also see aggregated figures:
+
+#+BEGIN_SRC sh
+   fin monthly
+
+   fin yearly
+#+END_SRC
+
+and combine these to view however many transactions you want:
+
+#+BEGIN_SRC sh
+   fin monthly transactions 24
+#+END_SRC
+
+You can also use the word 'records' instead of 'transactions'.
+
+By default transactions will be timestamped according to the system time when they are entered.  Optionally it is possible to adjust the time using the *time* option.  For example:
+
+#+BEGIN_SRC sh
+   fin receive 2.50 from "back of sofa" time 3.45pm
+#+END_SRC
+
+
+* _Brief Status Messages_
+
+It's also possible to produce brief status messages suitable either for including into *.bashrc* files, or for sending to a text-to-speech system.
+
+** Balance
+
+To report the balance for the currently selected account.
+
+#+BEGIN_SRC sh
+  fin say
+
+  fin say | espeak
+#+END_SRC
+
+** Average Income
+
+To see what your average income has been over the previous year.
+
+#+BEGIN_SRC sh
+  fin say income
+
+  fin say income | espeak
+#+END_SRC
+
+** Average Spending
+
+To see what your average spending rate has been over the previous year.
+
+#+BEGIN_SRC sh
+  fin say spending
+
+  fin say spend | espeak
+#+END_SRC
+
+The spending status message will also provide an estimate of when your funds will run out, or if the balance is negative how long it will take to pay off the debt or overdraft at the current average rate of income and spending.  This can help to provide an indication of whether your current rate of income and spending are sustainable or not, based upon the previous years transactions.  If you want to improve this time estimate you can also include average inflation and interest rates.
+
+So for example in the case of a savings account where the balance is positive.
+
+#+BEGIN_SRC sh
+  fin say spend interest 1.5 inflation 2.0
+#+END_SRC
+
+Sets an average savings interest rate of 1.5% per year and an average inflation rate of 2% per year.  Or for a current account which is overdrawn and has a usury rate (APR) of 18%.
+
+#+BEGIN_SRC sh
+  fin say spend apr 18 inflation 2.0
+
+  fin say spending usury 18 inflation 2.0 | espeak
+#+END_SRC
+
+** Personal Inflation Rate
+
+Indepentently from national inflation rates you can also get an idea of your own personal inflation rate.
+
+#+BEGIN_SRC sh
+  fin say inflation
+
+  fin say inflation | espeak
+#+END_SRC
+
+This compares spending within the previous three months with the same three months a year ago, and will report the percentage by which these values have changed.
+
+
+* _Searching_
+
+To search for transactions with particular words:
+
+#+BEGIN_SRC sh
+   fin find <words>
+#+END_SRC
+
+Note that multiple words should be surrounded by quotes, such as:
+
+#+BEGIN_SRC sh
+   fin find "cheese sandwich"
+#+END_SRC
+
+You can also use wildcards:
+
+#+BEGIN_SRC sh
+   fin find "*cheese*"
+#+END_SRC
+
+Or with multiple strings:
+
+#+BEGIN_SRC sh
+   fin find "cheese, bread, butter"
+#+END_SRC
+
+It's also possible to search by months or years:
+
+#+BEGIN_SRC sh
+   fin find "*" month jan
+   fin find "*" year 2011
+#+END_SRC
+
+As an alternative to "find" you can also use the word "search".
+
+You can also aggregate figures on a monthly basis.
+
+#+BEGIN_SRC sh
+   fin find "*groceries*" monthly
+#+END_SRC
+
+
+* _Deleting transactions_
+
+To delete a transaction first locate the record number on the far left hand side by typing "fin" or doing a search, then type:
+
+#+BEGIN_SRC sh
+   fin undo <record number>
+#+END_SRC
+
+
+* _Editing transactions_
+
+The status or description for a transaction can be edited as follows:
+
+#+BEGIN_SRC sh
+   fin edit <record number> status <new status> description <new description>
+
+   fin edit 2 status "complete"
+
+   fin edit 3 description "groceries"
+
+   fin edit 1 date "15/08/2016"
+#+END_SRC
+
+The record number is the number shown to the far left when you type "fin" or do a search.  If you wish to change the date or values then use the undo command and create a new transaction.
+
+All edits are recorded, and can be viewed by typing:
+
+#+BEGIN_SRC sh
+  fin edits
+#+END_SRC
+
+So if you make a change by mistake it's always possible to see what the previous values were.  The letter on the left hand side indicates different types of edit.
+
+#+BEGIN_SRC sh
+  B    The state of the transaction before the edit was made
+
+  A    The state of the transaction after the edit was made
+
+  D    A deleted transaction
+#+END_SRC
+
+If necessary you can also search through the edits.
+
+#+BEGIN_SRC sh
+  fin edits search "*cheese*"
+
+  fin edits search "*" year 2012
+
+  fin edits search "*" month dec
+#+END_SRC
+
+
+* _Multiple Accounts_
+
+By default any transactions will be added to an account called "current".
+
+To create other accounts, or to switch to another account use the following
+
+#+BEGIN_SRC sh
+   fin account <name>
+#+END_SRC
+
+For example:
+
+#+BEGIN_SRC sh
+   fin account savings
+   fin account expenses
+#+END_SRC
+
+All account data is stored in the directory called ".fin" in your home directory (~/.fin).
+
+Or just to send a particular transaction to a particular account:
+
+#+BEGIN_SRC sh
+   fin spend 2.99 on chips account:expenses
+#+END_SRC
+
+
+* _Transfering between accounts_
+
+To transfer an ammount from one account to another:
+
+#+BEGIN_SRC sh
+   fin transfer <amount> to <account name>
+#+END_SRC
+
+For example:
+
+#+BEGIN_SRC sh
+   fin transfer 10.29 to savings
+#+END_SRC
+
+This will transfer 10.29 from whatever is the currently active account (you can check that by typing "fin") to the savings account.
+
+
+* _Synchronising across multiple machines_
+
+Often people use more than one computer, and want to be able to transfer data.  Fin does this using the scp command, in order to push or pull data from an ssh server.
+
+To push the data to a server:
+
+#+BEGIN_SRC sh
+   fin push <domain>:<directory>
+
+   fin push mydomainname.com:/home/myusername
+#+END_SRC
+
+Optionally you can also include the username for the remote system if it differs from your local username.  If you get a /"permission denied"/ message when attempting to push or pull then try one of the following:
+
+#+BEGIN_SRC sh
+   fin username <myusername> push mydomainname.com:/home/myusername
+
+   fin username <myusername> pull mydomainname.com:/home/myusername
+#+END_SRC
+
+
+Subsequently you can then just type:
+
+#+BEGIN_SRC sh
+   fin push
+#+END_SRC
+
+The same also applies to retrieve data from a server:
+
+#+BEGIN_SRC sh
+   fin pull
+#+END_SRC
+
+
+* _Changing currencies_
+
+It's possible to log amounts in multiple currencies, for example:
+
+#+BEGIN_SRC sh
+    fin spend 3.40 on milk curr:EUR
+#+END_SRC
+
+means that the amount spent was in Euros.  Currencies are always given as a three character code (GBP, USD, BTC, etc).
+
+You can also change the default currency:
+
+#+BEGIN_SRC sh
+    fin currency USD
+#+END_SRC
+
+with any subsequent transactions then occurring in that currency by default.
+
+
+* _Importing data_
+
+** From CSV
+
+Data can be imported from a CSV file, which is a common way of exporting bank transactions from online accounts.  The first line of the file is assumed to be a header containing field names.
+
+The expected field names are "Date", "Money in", "Money out", "Spent", "Spend", "Amount", "Memo", "Description", "Subcategory".  Not all of those field names need to be present for the import to be successful, and fields such as "description" and "memo" mean the same thing.  The currency type and date format are assumed to be whatever has been set as the defaults.
+
+To import:
+
+#+BEGIN_SRC sh
+    fin import <filename>
+
+    fin import mybankstatement.csv
+#+END_SRC
+
+The filename should have a /.csv/ extension.
+
+In case the same file is imported more than once the system attempts to avoid adding duplicate transactions.
+
+
+** From Emacs org mode tables
+
+Tables created with Emacs org mode, such as a shopping list or parts list, can also be imported.
+
+As with CSV, the expected fields can include "Date", "Money in", "Money out", "Spent", "Spend", "Amount", "Memo", "Description" or "Subcategory".
+
+Here's an example table:
+
+  | Date       | Description     | Spent |
+  |------------+-----------------+-------|
+  | 03/05/2012 | Cheese sandwich |  1.50 |
+  | 03/05/2012 | Teacup          |  2.00 |
+  | 04/05/2012 | Butter          |  1.20 |
+
+Note that if you use the "Amount" field name then a positive value means money received and a negative value indicates money spent.
+
+#+BEGIN_SRC sh
+    fin import mynotes.txt
+#+END_SRC
+
+
+** From GnuCash
+
+To import from GnuCash first create a new account if you need one.
+
+#+BEGIN_SRC sh
+  fin account [account name]
+#+END_SRC
+
+Then import the *.gnucash* file.
+
+#+BEGIN_SRC sh
+  fin import myaccounts.gnucash
+#+END_SRC
+
+The GnuCash file will be examined and any active accounts will be listed.  You should then enter the name of the account that you wish to import.
+
+If you subsequently need to export back to GnuCash then you can use the CSV export feature described below.
+
+
+* _Exporting data_
+
+** CSV
+
+You can export data in CSV format for viewing in a spreadsheet or import into other systems.
+
+#+BEGIN_SRC sh
+    fin find "*" export myexportfilename.csv
+#+END_SRC
+
+Obviously you can use search strings to narrow down the data set.  It's also possible to specify the separator used between fields.
+
+#+BEGIN_SRC sh
+    fin find "*" export myexportfilename.csv separator tab
+
+    fin find "*" export myexportfilename.csv separator ,
+#+END_SRC
+
+You can also export aggregated figures:
+
+#+BEGIN_SRC sh
+    fin export myexportfilename.csv monthly
+
+    fin export myexportfilename.csv yearly
+#+END_SRC
+
+** Emacs
+
+Data can be exported to Emacs in the form of org mode formatted tables.
+
+To show results in tabular form add the option /style emacs/.
+
+ When performing a search:
+
+#+BEGIN_SRC sh
+    fin search "*shopping*" style emacs > shopping_list.txt
+#+END_SRC
+
+Monthly:
+
+#+BEGIN_SRC sh
+    fin style emacs monthly > monthly.txt
+#+END_SRC
+
+Or yearly
+
+#+BEGIN_SRC sh
+    fin style emacs yearly > yearly.txt
+#+END_SRC
+
+
+* _Date formats_
+
+You can change the date format used in the following way:
+
+#+BEGIN_SRC sh
+    fin dateformat "%d/%m/%Y"
+
+    fin dateformat "%m/%d/%Y"
+#+END_SRC
+
+Only the %d, %m and %Y fields are supported.
+
+
+* _Plotting_
+
+** Balance
+
+You can plot monthly balance figures using the following command:
+
+#+BEGIN_SRC sh
+    fin monthly <image filename>
+
+    fin monthly balance.png transactions 100
+#+END_SRC
+
+The image which is output is in PNG format, and gnuplot needs to be installed for this to work.
+
+Perhaps even more useful is to plot particular kinds of expenditure over time by using the search function.  For example:
+
+#+BEGIN_SRC sh
+    fin find "*groceries*" monthly groceries.png
+#+END_SRC
+
+Will output an image showing spending on groceries on a monthly basis over time. The "*" wildcards can be used to search for any description field containing a particular word.
+
+** Spending Distribution
+
+You can plot the overall distribution of amounts spent in the following way:
+
+#+BEGIN_SRC sh
+  fin distribution spending.png startyear 2007 endyear 2012 maximum 200
+#+END_SRC
+
+or for an individual year.
+
+#+BEGIN_SRC sh
+  fin distribution spending.png year 2012 maximum 100
+#+END_SRC
+
+Where /startyear/ and /endyear/ specify the range of years, and /maximum/ denotes the maximum amount.  If an image file is not specified then the results will be listed in CSV format, or emacs org-mode table format if you use the /style emacs/ option. You can also apply a search string to show the spending distribution for a particular type of item.
+
+#+BEGIN_SRC sh
+  fin distribution spending.png year 2015 maximum 100 search "*supermarket*,*groceries*"
+#+END_SRC
+
+** Transaction Volumes
+
+The number of transactions per month can be shown as follows:
+
+  fin volume
+
+or plotted in a graph:
+
+  fin volume mytransactions.png
+
+As usual you can also apply search criteria and increase or decrease the number of months shown using the *transactions* option.
+
+  fin volume mytransactions.png search "*supermarket*" transactions 50
+
+** Pie Charts
+
+Another way of looking at spending is to find out what percentage of income was spent on various things.  This can be done with the /piechart/ command:
+
+#+BEGIN_SRC sh
+    fin piechart year 2008 search "*fuel*,*supermarket*,*car*"
+
+    fin piechart year 2009 search "*fuel*|Petrol,*supermarket*|Food,*car*|Car repairs/insurance,*savings*"
+#+END_SRC
+
+The "|" character is used to specify an alias name corresponding to each search.  You can also export the data to a CSV or text file, which will then allow you to create pie charts using LibreOffice or similar software.
+
+#+BEGIN_SRC sh
+    fin piechart spending.csv year 2008 search "*fuel*,*supermarket*,*car*"
+
+    fin piechart spending.csv month july search "*fuel*|Petrol,*supermarket*|Food,*car*|Car repairs/insurance,*savings*"
+#+END_SRC
+
+Or you can also plot to an image.
+
+#+BEGIN_SRC sh
+    fin piechart chart.png year 2010 search "*fuel*|Petrol,*supermarket*|Food,*car*|Car repairs/insurance,*savings*"
+#+END_SRC
+
+A subtlety here is that you can combine searches into a single category using the "+" sign.  For example, to merge "car" and "fuel" into a single category:
+
+#+BEGIN_SRC sh
+    fin piechart chart.png year 2010 search "*car*+*fuel*|Total Car,*supermarket*|Food,*savings*"
+#+END_SRC
+
+
+* _Geolocation_
+
+Although it's not typical at the time of writing it is expected that embedded devices such as phones will eventually become a replacement for conventional wallets and physical cash, so it might also be useful to be able to log the locations of transactions.  Optionally, a geolocation can be associated with each transaction.
+
+#+BEGIN_SRC sh
+    fin spend 9.99 on book long:1.2 lat:41.6 alt:52.1
+#+END_SRC
+
+This information can subsequently be exported as part of a search:
+
+#+BEGIN_SRC sh
+    fin find "*" kml <filename>
+
+    fin find "*" year 2011 kml <filename>
+#+END_SRC
+
+
+* _Security_
+
+Ordinarily the "data at rest" within the ~/.fin directory is not encrypted.  Since financial data may often be confidential there is an easy way to encrypt the data when you're not using it.
+
+#+BEGIN_SRC sh
+    fin lock
+#+END_SRC
+
+You will be prompted to enter a password, then the files will be encrypted.  The next time you run fin you will then be prompted for the password.

+ 23 - 0
debian.sh

@@ -0,0 +1,23 @@
+#!/bin/bash
+
+APP=fin
+VERSION=1.42
+ARCH_TYPE=`uname -m`
+
+if [ $ARCH_TYPE == "x86_64" ]; then
+    ARCH_TYPE="amd64"
+fi
+if [ $ARCH_TYPE == "i686" ]; then
+    ARCH_TYPE="i386"
+fi
+
+# Create a source archive
+make clean
+make source
+
+# Build the package
+fakeroot dpkg-buildpackage -F
+
+# sign files
+gpg -ba ../${APP}_${VERSION}-1_${ARCH_TYPE}.deb
+gpg -ba ../${APP}_${VERSION}.orig.tar.gz

+ 52 - 0
debian/changelog

@@ -0,0 +1,52 @@
+fin (1.42-1) unstable; urgency=low
+
+  * Adjustments description spans multiple lines
+
+ -- Bob Mottram (4096 bits) <bob@sluggish.dyndns.org>  Thu, 14 Feb 2013 14:50:00 +0100
+
+fin (1.41-1) unstable; urgency=low
+
+  * Import transactions from GnuCash
+
+  * Edits and deletions
+    are recorded in an adjustments table
+
+  * Time of transaction included with date
+
+  * Pie charts can now be plotted
+
+ -- Bob Mottram (4096 bits) <bob@sluggish.dyndns.org>  Tue, 09 Oct 2012 18:00:00 +0100
+
+fin (1.40-1) unstable; urgency=low
+
+  * Improvements to import function
+    Data can be exported from Paypal as csv and imported into
+    fin with no editing required. Also a bug related to the
+    transaction numbers during the import process was fixed.
+
+  * Multiple search criteria are now allowed
+    Search string can contain multiple fields separated by commas
+
+  * Spending distribution graph
+
+  * Colour coding
+    Of positive/negative incoming/outgoing figures
+
+  * Long descriptions
+    Are now displayed over multiple rows
+
+  * Three digit record numbers
+    Should be enough to cover most situations
+
+  * More unit test coverage
+
+  * Short status messages
+    Including forecasting of when funds will be depleted
+
+  * General code tidying
+    Try to keep most lines to less than 80 characters
+
+  * Debian packaging improvements
+    Now passes lintian tests
+
+ -- Bob Mottram (4096 bits) <bob@sluggish.dyndns.org>  Tue, 02 Oct 2012 20:00:00 +0100

+ 1 - 0
debian/compat

@@ -0,0 +1 @@
+8

+ 26 - 0
debian/control

@@ -0,0 +1,26 @@
+Source: fin
+Section: contrib/utils
+Priority: extra
+Maintainer: Bob Mottram <bob@sluggish.dyndns.org>
+Build-Depends: debhelper (>= 8.0.0), libsqlite3-dev
+Standards-Version: 3.9.2
+Homepage: https://launchpad.net/fin
+Vcs-Bzr: https://code.launchpad.net/fin
+Vcs-Browser: http://bazaar.launchpad.net/~fuzzgun/fin/trunk/files
+#Vcs-Git: git://git.debian.org/collab-maint/fin.git
+#Vcs-Browser: http://git.debian.org/?p=collab-maint/fin.git;a=summary
+
+Package: fin
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, gnuplot, bcrypt, libsqlite3-0
+Description: Command line personal finances manager
+ Keeping track of personal finances is an incredibly boring task, and if
+ you don't have much money then juggling it can be tricky.  When looking
+ at the existing software out there to manage accounts it's frequently
+ highly complex and top heavy.  Fin - an abbreviation of "financials" -
+ is an attempt to do the opposite of what most accounting software does,
+ and that's to make things incredibly simple and quick.  Logging a
+ transaction or viewing your current balance should take no more than a
+ few seconds.  This means less time wasted on bureaucracy and more time
+ spent on what you really want to be doing.  Fin can import and export
+ to CSV files, Emacs org mode tables and GnuCash.

+ 26 - 0
debian/copyright

@@ -0,0 +1,26 @@
+Format: http://dep.debian.net/deps/dep5
+Upstream-Name: fin
+Source: https://code.launchpad.net/fin
+
+Files: *
+Copyright: 2011-2012 Bob Mottram <bob@sluggish.dyndns.org>
+
+Files: debian/*
+Copyright: 2012 Bob Mottram <bob@sluggish.dyndns.org>
+
+License: GPL-3.0+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
+ .
+ This package is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ .
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>.
+ .
+ On Debian systems, the complete text of the GNU General
+ Public License version 3 can be found in "/usr/share/common-licenses/GPL-3".

+ 1 - 0
debian/docs

@@ -0,0 +1 @@
+README

+ 1 - 0
debian/files

@@ -0,0 +1 @@
+fin_1.42-1_amd64.deb contrib/utils extra

+ 60 - 0
debian/rules

@@ -0,0 +1,60 @@
+#!/usr/bin/make -f
+
+APP=fin
+
+fin_application = $(CURDIR)/$(APP)
+man_page = $(CURDIR)/man/$(APP).1.gz
+
+DEST_APP = $(CURDIR)/debian/$(APP)/usr/bin
+DEST_MAN = $(CURDIR)/debian/$(APP)/usr/share/man/man1
+
+CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
+CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
+
+build: build-stamp
+	gcc -Wall -ansi -pedantic -O3 $(CFLAGS) $(LDFLAGS) $(CPPFLAGS) $(CXXFLAGS) -o $(APP) src/*.c -Isrc -lsqlite3
+
+build-stamp:
+		dh_testdir
+		touch build-stamp
+
+clean:
+		dh_testdir
+		dh_testroot
+		rm -f build-stamp
+		dh_clean
+
+install: build clean $(fin_application) $(man_page)
+		 dh_testdir
+		 dh_testroot
+		 dh_prep
+		 dh_installdirs
+
+		 mkdir -m 755 -p $(DEST_APP)
+		 mkdir -m 755 -p $(DEST_MAN)
+
+		 install -m 755 --strip $(fin_application) $(DEST_APP)
+		 install -m 644 $(man_page) $(DEST_MAN)
+
+binary-indep: build install
+			  dh_shlibdeps
+			  dh_testdir
+			  dh_testroot
+			  dh_installchangelogs
+			  dh_installdocs
+			  dh_installexamples
+			  dh_installman
+			  dh_link
+			  dh_compress
+			  dh_fixperms
+			  dh_installdeb
+			  dh_gencontrol
+			  dh_md5sums
+			  dh_builddeb
+
+binary-arch: build install
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install

+ 1 - 0
debian/source/format

@@ -0,0 +1 @@
+3.0 (quilt)

+ 4 - 0
debian/source/include-binaries

@@ -0,0 +1,4 @@
+man/fin.1.gz
+img/logo192.png
+img/logo64.png
+img/logo14.png

+ 1 - 0
edit.sh

@@ -0,0 +1 @@
+emacs -nw *.sh README fin.txt LICENSE man/* debian/* rpmpackage/*.spec rpmpackage/*.conf src/*.c src/*.h Makefile

+ 45 - 0
fedora.sh

@@ -0,0 +1,45 @@
+APP=fin
+VERSION=1.42
+SOURCEDIR=.
+ARCH_TYPE=`uname -m`
+
+sudo yum groupinstall "Development Tools"
+sudo yum install rpmdevtools sqlite-devel bcrypt gnuplot
+
+make
+
+rm -rf ~/rpmbuild
+sudo rm -rf rpmpackage/$APP-$VERSION
+rpmdev-setuptree
+mkdir rpmpackage/$APP-$VERSION
+
+mkdir rpmpackage/$APP-$VERSION/etc
+mkdir rpmpackage/$APP-$VERSION/etc/$APP
+mkdir rpmpackage/$APP-$VERSION/usr
+mkdir rpmpackage/$APP-$VERSION/usr/bin
+mkdir rpmpackage/$APP-$VERSION/usr/share
+mkdir rpmpackage/$APP-$VERSION/usr/share/man
+mkdir rpmpackage/$APP-$VERSION/usr/share/man/man1
+install -m 755 $APP rpmpackage/$APP-$VERSION/usr/bin
+install -m 755 man/$APP.1.gz rpmpackage/$APP-$VERSION/usr/share/man/man1
+
+cd rpmpackage
+mkdir $APP-$VERSION/etc/$APP
+install -m 644 $APP.conf $APP-$VERSION/etc/$APP/
+tar -zcvf $APP-$VERSION.tar.gz $APP-$VERSION/
+
+rm -rf ~/rpmbuild/BUILD/$APP-$VERSION
+rm ~/rpmbuild/SOURCES/$APP*.*
+cp $APP-$VERSION.tar.gz ~/rpmbuild/SOURCES/
+cp $APP.spec ~/rpmbuild/SPECS/
+
+rpmbuild -ba ~/rpmbuild/SPECS/$APP.spec
+
+sudo rm -rf $APP-$VERSION
+rm $APP-$VERSION.tar.gz
+cp -r ~/rpmbuild/RPMS/* .
+cd ..
+echo ---------------------------------------------------------
+echo RPM files can be found in the rpmpackage directory
+echo under architecture subdirectories.
+echo ---------------------------------------------------------

BIN
img/logo14.png


BIN
img/logo192.png


BIN
img/logo64.png


BIN
man/fin.1.gz


+ 1 - 0
rpmpackage/fin.conf

@@ -0,0 +1 @@
+ 

+ 58 - 0
rpmpackage/fin.spec

@@ -0,0 +1,58 @@
+#
+# rpm spec for fin
+#
+
+%define        __spec_install_post %{nil}
+%define          debug_package %{nil}
+%define        __os_install_post %{_dbpath}/brp-compress
+
+Summary: A commandline personal finances manager
+Name: fin
+Version: 1.42
+Release: 1
+License: GPL3
+Group: Utils
+SOURCE0 : %{name}-%{version}.tar.gz
+URL: https://launchpad.net/fin
+Packager: Bob Mottram <bob@sluggish.dyndns.org>
+Requires: sqlite, sqlite-devel, gnuplot, bcrypt
+BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
+
+%description
+ Keeping track of personal finances is an incredibly boring task, and if
+ you don't have much money then juggling it can be tricky.  When looking
+ at the existing software out there to manage accounts it's frequently
+ highly complex and top heavy.  Fin - an abbreviation of 'financials' -
+ is an attempt to do the opposite of what most accounting software does,
+ and that's to make things incredibly simple and quick.  Logging a
+ transaction or viewing your current balance should take no more than a
+ few seconds.  This means less time wasted on bureaucracy and more time
+ spent on what you really want to be doing.  Fin can import and export
+ to CSV files, Emacs org mode tables and GnuCash.
+
+%prep
+%setup -q
+
+%build
+ # Empty section.
+
+%install
+rm -rf %{buildroot}
+mkdir -p  %{buildroot}
+
+# in builddir
+cp -a * %{buildroot}
+
+%clean
+rm -rf %{buildroot}
+
+%files
+%defattr(-,root,root,-)
+%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
+%{_bindir}/*
+%attr(644,root,root) /usr/share/man/man1/fin.1.gz
+
+%changelog
+* Fri Jan 20 2012  Bob Mottram <bob@sluggish.dyndns.org>
+- Spec file created
+

+ 24 - 0
src/calendar.c

@@ -0,0 +1,24 @@
+/*
+    Fin - a simple personal accounts manager
+    Copyright (C) 2012-2013  Bob Mottram <bob@sluggish.dyndns.org>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "calendar.h"
+
+int command_calendar(int argc, char* argv[])
+{
+	return 1;
+}

+ 27 - 0
src/calendar.h

@@ -0,0 +1,27 @@
+/*
+    Fin - a simple personal accounts manager
+    Copyright (C) 2012-2013  Bob Mottram <bob@sluggish.dyndns.org>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef CALENDAR_H
+#define CALENDAR_H
+
+#include "parse.h"
+#include "database.h"
+
+int command_calendar(int argc, char* argv[]);
+
+#endif

+ 394 - 0
src/conversions.c

@@ -0,0 +1,394 @@
+/*
+  Fin - a simple personal accounts manager
+  Copyright (C) 2012-2013  Bob Mottram <bob@sluggish.dyndns.org>
+
+  This program is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "conversions.h"
+
+static void value_to_integer(char * money, char * integer,
+							 int decimal_places)
+{
+	int i,ctr=0;
+	char intval[STRING_BLOCK];
+	char decval[STRING_BLOCK];
+
+	for (i=0;i<strlen(money);i++) {
+		if (money[i]=='.') {
+			break;
+		}
+		if ((money[i]>='0') && (money[i]<='9')) {
+			intval[ctr++]=money[i];
+		}
+	}
+	intval[ctr]=0;
+	if (i==strlen(money)) {
+		ctr=0;
+		for (i=0;i<strlen(money);i++) {
+			if (money[i]==',') {
+				break;
+			}
+			if ((money[i]>='0') && (money[i]<='9')) {
+				intval[ctr++]=money[i];
+			}
+		}
+		intval[ctr]=0;
+	}
+
+	i++;
+	ctr=0;
+	while (i<strlen(money)) {
+		if ((money[i]>='0') && (money[i]<='9')) {
+			decval[ctr++]=money[i];
+		}
+		i++;
+	}
+	decval[ctr]=0;
+  
+	ctr=0;
+	for (i=0;i<strlen(intval);i++) {
+		integer[ctr++] = intval[i];
+	}
+	for (i=0;i<strlen(decval);i++) {
+		integer[ctr++] = decval[i];
+	}
+	for (i=0;i<decimal_places-strlen(decval);i++) {
+		integer[ctr++] = '0';
+	}
+	integer[ctr]=0;
+}
+
+static void integer_to_value(char * integer, char * money,
+							 int decimal_places)
+{
+	int i,ctr=0;
+
+	for (i=0;i<strlen(integer)-decimal_places;i++) {
+		money[ctr++]=integer[i];
+	}
+	money[ctr++]='.';
+	while (i<strlen(integer)) {
+		money[ctr++]=integer[i];
+		i++;
+	}
+	money[ctr]=0;
+}
+
+void money_to_integer(char * money, char * integer)
+{
+	value_to_integer(money,integer, DECIMAL_PLACES);
+}
+
+void integer_to_money(char * integer, char * money)
+{
+	integer_to_value(integer, money, DECIMAL_PLACES);
+}
+
+void quantity_to_integer(char * money, char * integer)
+{
+	value_to_integer(money,integer, DECIMAL_PLACES_QUANTITY);
+}
+
+void integer_to_quantity(char * integer, char * money)
+{
+	integer_to_value(integer, money, DECIMAL_PLACES_QUANTITY);
+}
+
+void pad_text(char * str, int width)
+{
+	int i;
+	for (i=strlen(str);i<width;i++) {
+		str[i]=' ';
+	}
+	str[i]=0;
+}
+
+void pad_value(char * value, char * padded,
+			   int leading_spaces, int trailing_zeros)
+{
+	int i,decimal_point=-1,zeros,leading;
+	char temp[32];
+
+	if (value==0) return;
+
+	sprintf(temp,"%s",value);
+
+	for (i=0;i<strlen(value);i++) {
+		if (value[i]=='.') {
+			decimal_point = i;
+		}
+	}
+	if (decimal_point==-1) {
+		for (i=0;i<strlen(value);i++) {
+			if (value[i]==',') {
+				decimal_point = i;
+			}
+		}
+	}
+
+	if (decimal_point>-1) {
+		zeros = trailing_zeros+1 - (strlen(value) - decimal_point);
+		if (zeros<0) {
+			temp[strlen(value)+zeros] = 0;
+		}
+		for (i=0;i<zeros;i++) {
+			temp[strlen(value)+i] = '0';
+		}
+		temp[strlen(value)+i] = 0;
+	}
+	else {
+		temp[strlen(value)]='.';
+		for (i=0;i<trailing_zeros;i++) {
+			temp[strlen(value)+i+1]='0';
+		}
+		temp[strlen(value)+i+1]=0;
+	}
+
+	if (decimal_point==-1) {
+		decimal_point = strlen(value);
+	}
+	leading = leading_spaces - decimal_point - 1;
+	for (i=0;i<leading;i++) {
+		padded[i]=' ';
+	}
+	for (i=0;i<strlen(temp);i++) {
+		padded[leading+i] = temp[i];
+	}
+	padded[leading+i]=0;
+}
+
+/* convert a time string into a standard form */
+void convert_time_to_standard(char * timestr, char * converted,
+							  char * am, char * pm)
+{
+	int i, ctr = 0, state = 0;
+	int hr = 0, min = 0, sec = 0;
+	char str[STRING_BLOCK];
+
+	/* handle empty string */
+	if (timestr[0]==0) {
+		converted[0]=0;
+		return;
+	}
+
+	/* convert to lower case */
+	for (i = 0; i < strlen(timestr); i++) {
+		timestr[i] = tolower(timestr[i]);
+	}
+
+	for (i = 0; i < strlen(timestr); i++) {
+		if ((timestr[i]==am[0]) ||
+			(timestr[i]==pm[0])) {
+			str[ctr]=0;
+			switch(state) {
+			case 0: {
+				hr = atoi(str);
+				if (timestr[i]==pm[0]) {
+					if (hr < 12) hr += 12;
+				}
+				break;
+			}
+			case 1: { min = atoi(str); break; }
+			case 2: { sec = atoi(str); break; }
+			}
+			break;
+		}
+		if ((timestr[i]==':') ||
+			(timestr[i]=='.') || (i == strlen(timestr)-1)) {
+			if (i == strlen(timestr)-1) {
+				str[ctr++] = timestr[i];
+			}
+			str[ctr]=0;
+			switch(state) {
+			case 0: { hr = atoi(str); break; }
+			case 1: { min = atoi(str); break; }
+			case 2: { sec = atoi(str); break; }
+			}
+			ctr = 0;
+			state++;
+		}
+		else {
+			str[ctr++] = timestr[i];
+		}
+	}
+
+	sprintf(converted,"%02d:%02d:%02d",hr,min,sec);
+}
+
+/* convert a date to a standard format for storage in the database */
+void convert_date_to_standard(char * date, char * date_format,
+							  char * converted)
+{
+	int i,month=1,day=1,year=0;
+	char str[10];
+
+	for (i=0;i<strlen(date_format)-1;i++) {
+		if (date_format[i]=='%') {
+			if (date_format[i+1]=='m') {
+				str[0]=date[i];
+				str[1]=date[i+1];
+				str[2]=0;
+				month = atoi((char*)str);
+			}
+			if (date_format[i+1]=='d') {
+				str[0]=date[i];
+				str[1]=date[i+1];
+				str[2]=0;
+				day = atoi((char*)str);
+			}
+			if (date_format[i+1]=='Y') {
+				str[0]=date[i];
+				str[1]=date[i+1];
+				str[2]=date[i+2];
+				str[3]=date[i+3];
+				str[4]=0;
+				year = atoi((char*)str);
+			}
+		}
+	}
+	sprintf(converted,"%04d-%02d-%02d",year,month,day);
+}
+
+/* convert a date from the database into the desired date format */
+void convert_standard_to_date(char * standard, char * date_format,
+							  char * date)
+{
+	char str[5];
+	int day,month,year,i;
+
+	str[0] = standard[0];
+	str[1] = standard[1];
+	str[2] = standard[2];
+	str[3] = standard[3];
+	str[4] = 0;
+	year = atoi((char*)str);
+
+	str[0] = standard[5];
+	str[1] = standard[6];
+	str[2] = 0;
+	month = atoi((char*)str);
+
+	str[0] = standard[8];
+	str[1] = standard[9];
+	str[2] = 0;
+	day = atoi((char*)str);
+
+	sprintf(date,"%s",date_format);
+
+	for (i=0;i<strlen(date_format)-1;i++) {
+		if (date_format[i]=='%') {
+			if (date_format[i+1]=='m') {
+				sprintf((char*)&date[i],"%02d",month);
+			}
+			if (date_format[i+1]=='d') {
+				sprintf((char*)&date[i],"%02d",day);
+			}
+			if (date_format[i+1]=='Y') {
+				sprintf((char*)&date[i],"%04d",year);
+			}
+		}
+	}
+	for (i=0;i<strlen(date_format);i++) {
+		if ((date_format[i]=='/') ||
+			(date_format[i]=='-') ||
+			(date_format[i]=='.')) {
+			date[i] = date_format[i];
+		}
+	}
+	date[10]=0;
+}
+
+int reverse_file(char * filename)
+{
+	FILE * fp;
+	int i,row,rows=0,retval=0;
+	char line[STRING_BLOCK];
+	char header[STRING_BLOCK];
+	char * output_filename = "temp_reverse.txt";
+
+	/* count the number of rows */
+	fp = fopen(filename,"r");
+	if (fp!=0) {
+		while (!feof(fp)) {
+			if (fgets(line , 255 , fp) != NULL ) {
+				if (rows==0) {
+					sprintf((char*)header,"%s",line);
+				}
+				rows++;
+			}      
+		}
+		fclose(fp);
+	}
+
+	fp = fopen(output_filename,"w");
+	if (fp!=0) {
+		fprintf(fp,"%s",header);
+		fclose(fp);
+	}
+
+	for (i=rows;i>1;i--) {
+		row = 0;
+		fp = fopen(filename,"r");
+		if (fp!=0) {
+			while ((!feof(fp)) && (row<i)) {
+				if (fgets(line , 255 , fp) != NULL ) {
+					row++;
+				}      
+			}
+			fclose(fp);
+		}
+
+		fp = fopen(output_filename,"a");
+		if (fp!=0) {
+			fprintf(fp,"%s",line);
+			fclose(fp);
+		}    
+	}
+
+	if (rows>0) {
+		sprintf((char*)line,"rm %s", filename);
+		retval = system((char*)line);
+		sprintf((char*)line,"mv %s %s", output_filename, filename);
+		retval = system((char*)line);
+	}
+	return retval;
+}
+
+/* trims the first line from a text file */
+void trim_file_header(char * filename, char * trimmed)
+{
+	FILE * fp, * fp_trimmed;
+	int row=0;
+	char line[STRING_BLOCK];
+
+	fp = fopen(filename,"r");
+	if (fp!=0) {
+		fp_trimmed = fopen(trimmed,"w");
+		if (fp_trimmed!=0) {
+
+			while (!feof(fp)) {
+				if (fgets(line , 255 , fp) != NULL ) {
+					if (row>0) {
+						fprintf(fp_trimmed,"%s",line);
+					}
+					row++;
+				}	
+			}
+
+			fclose(fp_trimmed);
+		}   
+		fclose(fp);
+	}
+}

+ 48 - 0
src/conversions.h

@@ -0,0 +1,48 @@
+/*
+    Fin - a simple personal accounts manager
+    Copyright (C) 2012-2013  Bob Mottram <bob@sluggish.dyndns.org>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef CONVERSIONS_H
+#define CONVERSIONS_H
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include "globals.h"
+
+void money_to_integer(char * money, char * integer);
+void integer_to_money(char * integer, char * money);
+
+void quantity_to_integer(char * money, char * integer);
+void integer_to_quantity(char * integer, char * money);
+
+void pad_value(char * value, char * padded, int leading_spaces,
+			   int trailing_zeros);
+void pad_text(char * str, int width);
+
+void convert_date_to_standard(char * date,
+							  char * date_format, char * converted);
+void convert_standard_to_date(char * standard,
+							  char * date_format, char * date);
+
+int reverse_file(char * filename);
+void trim_file_header(char * filename, char * trimmed);
+void convert_time_to_standard(char * timestr, char * converted,
+							  char * am, char * pm);
+
+#endif

+ 1804 - 0
src/database.c

@@ -0,0 +1,1804 @@
+/*
+  Fin - a simple personal accounts manager
+  Copyright (C) 2012-2013  Bob Mottram <bob@sluggish.dyndns.org>
+
+  This program is free software: you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation, either version 3 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "database.h"
+
+void database_directory(char * directory)
+{
+	sprintf(directory,"%s/.fin",getenv("HOME"));
+}
+
+void database_name(char * account, char * filename)
+{
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+	sprintf(filename,"%s/%s.sqlite3",directory,account);
+}
+
+int file_exists(char * name)
+{
+	FILE * fp = fopen(name,"r");
+	if (fp!=0) {
+		fclose(fp);
+		return 1;
+	}
+	return 0;
+}
+
+int directory_exists(char * name)
+{
+	struct stat sts;
+	if ((stat(name, &sts)) == -1) {
+		return 0;
+	}
+	return 1;
+}
+
+int account_exists(char * name)
+{
+	FILE * fp;
+	char str[STRING_BLOCK];
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+	sprintf((char*)str,"%s/%s.sqlite3",directory, name);
+	fp = fopen(str,"r");
+	if (fp!=0L) {
+		fclose(fp);
+		return 1;
+	}
+	return 0;
+}
+
+int create_sqlite_adjustments_table(char * account)
+{
+	int retval;
+	char database_filename[128];
+        
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	char create_adjustments_table[] =
+		"CREATE TABLE IF NOT EXISTS adjustments (" \
+		"adjustment_date DATETIME," \
+		"adjustment_type CHAR(1)," \
+		"transaction_number TEXT," \
+		"date DATETIME," \
+		"qty DECIMAL," \
+		"description TEXT," \
+		"spend MONEY,"  \
+		"receive MONEY," \
+		"recur INTEGER," \
+		"currency CHAR(3)," \
+		"status TEXT," \
+		"invoice_number TEXT," \
+		"sales_number TEXT," \
+		"purchase_number TEXT," \
+		"works_number TEXT," \
+		"job_number TEXT," \
+		"serial_number TEXT," \
+		"part_number TEXT," \
+		"tracking_number TEXT," \
+		"progress DECIMAL," \
+		"latitude DECIMAL," \
+		"longitude DECIMAL," \
+		"altitude DECIMAL," \
+		"supplier TEXT," \
+		"customer TEXT," \
+		"vatrate DECIMAL" \
+		")";
+    
+	/* try to create the database. If it doesnt exist, it would be created
+	   pass a pointer to the pointer to sqlite3, in short sqlite3 */
+	database_name(account, (char*)database_filename);
+	retval = sqlite3_open_v2(database_filename,
+							 &handle,
+							 SQLITE_OPEN_READWRITE|SQLITE_OPEN_CREATE,
+							 NULL);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		return 0;
+	}
+
+	retval = sqlite3_exec(handle,create_adjustments_table,0,0,0);
+	if (retval) {
+		printf("Adjustments table creation failed. %s\n%s\n",
+			   sqlite3_errmsg(handle),create_adjustments_table);
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	sqlite3_close(handle);
+	return 1;
+}
+
+int create_sqlite_account(char * name)
+{
+	int retval;
+	char database_filename[128];
+        
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	char create_transactions_table[] =
+		"CREATE TABLE IF NOT EXISTS transactions (" \
+		"transaction_number TEXT PRIMARY KEY," \
+		"date DATETIME," \
+		"qty DECIMAL," \
+		"description TEXT," \
+		"spend MONEY,"  \
+		"receive MONEY," \
+		"recur INTEGER," \
+		"currency CHAR(3)," \
+		"status TEXT," \
+		"invoice_number TEXT," \
+		"sales_number TEXT," \
+		"purchase_number TEXT," \
+		"works_number TEXT," \
+		"job_number TEXT," \
+		"serial_number TEXT," \
+		"part_number TEXT," \
+		"tracking_number TEXT," \
+		"progress DECIMAL," \
+		"last_modified DATETIME," \
+		"latitude DECIMAL," \
+		"longitude DECIMAL," \
+		"altitude DECIMAL," \
+		"supplier TEXT," \
+		"customer TEXT," \
+		"vatrate DECIMAL" \
+		")";
+
+	/* try to create the database. If it doesnt exist, it would be created
+	   pass a pointer to the pointer to sqlite3, in short sqlite3 */
+	database_name(name, (char*)database_filename);
+	retval = sqlite3_open_v2(database_filename,
+							 &handle,
+							 SQLITE_OPEN_READWRITE|SQLITE_OPEN_CREATE,
+							 NULL);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		return 0;
+	}
+
+	retval = sqlite3_exec(handle,create_transactions_table,0,0,0);
+	if (retval) {
+		printf("Transactions table creation failed. %s\n%s\n",
+			   sqlite3_errmsg(handle),create_transactions_table);
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	sqlite3_close(handle);
+
+	/* create the adjustments table */
+	return create_sqlite_adjustments_table(name);
+}
+
+
+int create_sqlite_database()
+{
+	int retval=0;
+	char str[STRING_BLOCK];
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+
+	if (directory_exists(directory)==0) {
+		sprintf((char*)str,"mkdir %s",directory);
+		retval = system(str);
+	}
+	create_sqlite_account("current");
+	create_sqlite_account("savings");
+	return retval;
+}
+
+void get_current_datetime(char * result)
+{
+	time_t now;
+	struct tm *d;
+
+	time(&now);
+	d = localtime(&now);
+	sprintf(result,"%04d-%02d-%02d %02d:%02d:%02d",
+			d->tm_year+YEAR_BASELINE, d->tm_mon+1, d->tm_mday,
+			d->tm_hour, d->tm_min, d->tm_sec);
+}
+
+void get_transaction_identifier(char * spend, char * receive,
+								char * description,
+								char * transaction_identifier)
+{
+	int i,j,tot;
+	char str[16];
+	char nums[128];
+	time_t now;
+	int randval = (int)(rand()%999999);
+	struct tm *d;
+
+	j=0;
+	for (i=0;i<strlen(spend);i++) {
+		if ((spend[i]>='0') && (spend[i]<='9')) {
+			nums[j++] = spend[i];
+		}
+	}
+	for (i=0;i<strlen(receive);i++) {
+		if ((receive[i]>='0') && (receive[i]<='9')) {
+			nums[j++] = receive[i];
+		}
+	}
+	nums[j]=0;
+	time(&now);
+	d = localtime(&now);
+	strftime(str, 16, "%Y%m%d%H%M%S", d);
+	tot = 0;
+	for (i=0;i<strlen(description);i++) {
+		tot += (int)description[i];
+	}
+	sprintf(transaction_identifier,"%s%06d%s%03d",str,randval,nums,tot%1000);
+}
+
+int database_save_transaction(
+    char * account, char * date_format,
+	char * quantity, char * description,
+	char * spend, char * receive,
+	char * date, char * timestr, int recur,
+	char * currency, char * status,
+	char * invoice_number, char * sales_number,
+	char * purchase_number, char * works_number,
+	char * job_number, char * serial_number,
+	char * part_number, char * tracking_number,
+	float progress, char * latitude,
+	char * longitude, char * altitude,
+	char * supplier, char * customer, char * VATrate)
+{
+	int retval;
+	char database_filename[STRING_BLOCK];
+	char query[STRING_BLOCK*2];
+	char lat[32],lng[32],alt[32];
+	char transaction_identifier[STRING_BLOCK];
+	char curr[STRING_BLOCK],date_str[STRING_BLOCK];
+	char datetime[STRING_BLOCK];
+    
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	if ((date==0) || (strlen(date)==0)) {
+		printf("No date specified\n");
+		return 0;
+	}
+	if (is_date(date, date_format)==0) {
+		printf("%s is not a valid date format\n", date);
+		return 0;
+	}
+    
+	/* if no account is specified use the default one */
+	if (strlen(account)==0) {
+		settings_set_account(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT));
+		if (strlen(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT))==0) {
+			printf("Unable to get default account name\n");
+			return 0;
+		}
+		account = settings_get_account();
+	}
+
+	remove_currency_symbol(spend);
+	remove_currency_symbol(receive);
+
+	/* if no currency is given then use the default */
+	curr[0]=0;
+	if (strlen(currency)==0) {
+		settings_set_currency(get_text_from_identifier(SETTINGS_DEFAULT_CURRENCY));
+		if (strlen(get_text_from_identifier(SETTINGS_DEFAULT_CURRENCY))==0) {
+			printf("Unable to get default currency value\n");
+			return 0;
+		}
+		sprintf(curr,"%s",settings_get_currency());
+	}
+	else {
+		sprintf((char*)curr,"%s",currency);
+	}
+
+	create_sqlite_database();
+
+	if (strlen(account)==0) {
+		printf("No account specified\n");
+		return 0;
+	}
+
+	create_sqlite_account(account);
+
+	database_name(account, (char*)database_filename);
+	retval = sqlite3_open_v2(database_filename,
+							 &handle,
+							 SQLITE_OPEN_READWRITE|SQLITE_OPEN_CREATE,
+							 NULL);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		return 0;
+	}
+
+	sprintf(lat,"%s",latitude);
+	if (strlen(latitude)==0) {
+		sprintf(lat,"%s","0");
+	}
+	sprintf(lng,"%s",longitude);
+	if (strlen(longitude)==0) {
+		sprintf(lng,"%s","0");
+	}
+	sprintf(alt,"%s",altitude);
+	if (strlen(altitude)==0) {
+		sprintf(alt,"%s","0");
+	}
+
+	convert_date_to_standard(date,date_format,date_str);
+
+	get_transaction_identifier(spend,receive,
+							   description,
+							   (char*)transaction_identifier);
+
+	if (strlen(timestr)>0) {
+		sprintf(datetime,"%s %s",date_str,timestr);
+	}
+	else {
+		sprintf(datetime,"%s",date_str);
+	}
+
+	sprintf((char*)query,
+			"INSERT INTO transactions " \
+			"VALUES(\"%s\",\"%s\",%s,\"%s\",%s,%s,%d,\"%s\"," \
+			"\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\"," \
+			"\"%s\",\"%s\",%.3f,\"%s\",%s,%s,%s,\"%s\",\"%s\",%s);",
+			transaction_identifier,(char*)datetime,quantity,
+			description,spend,receive,recur,curr,status,
+			invoice_number,sales_number,purchase_number,
+			works_number,job_number,serial_number,
+			part_number,tracking_number,progress,(char*)datetime,
+			lat,lng,
+			alt,supplier,customer,VATrate);
+
+	retval = sqlite3_exec(handle,query,0,0,0);
+	if (retval) {
+		printf("Failed to insert record into transactions table. " \
+			   "%s\nTransaction %s\n%s\n",sqlite3_errmsg(handle),
+			   transaction_identifier,query);
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	sqlite3_close(handle);
+	return 1;
+}
+
+int database_save_adjustment(
+    char * account,
+	char * current_datetime,
+    char adjustment_type,
+	char * transaction_identifier,
+	char * quantity, char * description,
+	char * spend, char * receive,
+	char * date, char * timestr, int recur,
+	char * currency, char * status,
+	char * invoice_number, char * sales_number,
+	char * purchase_number, char * works_number,
+	char * job_number, char * serial_number,
+	char * part_number, char * tracking_number,
+	float progress, char * latitude,
+	char * longitude, char * altitude,
+	char * supplier, char * customer, char * VATrate)
+{
+	int retval;
+	char database_filename[STRING_BLOCK];
+	char query[STRING_BLOCK*2];
+	char lat[32],lng[32],alt[32];
+	char curr[STRING_BLOCK];
+	char datetime[STRING_BLOCK];
+    
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	if ((date==0) || (strlen(date)==0)) {
+		printf("No date specified\n");
+		return 0;
+	}
+
+	/* date is expected to be in the standard format */
+	if (is_date(date, "%Y-%m-%d")==0) {
+		printf("%s is not a valid date format\n", date);
+		return 0;
+	}
+    
+	/* if no account is specified use the default one */
+	if (strlen(account)==0) {
+		settings_set_account(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT));
+		if (strlen(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT))==0) {
+			printf("Unable to get default account name\n");
+			return 0;
+		}
+		account = settings_get_account();
+	}
+
+	remove_currency_symbol(spend);
+	remove_currency_symbol(receive);
+
+	/* if no currency is given then use the default */
+	curr[0]=0;
+	if (strlen(currency)==0) {
+		settings_set_currency(get_text_from_identifier(SETTINGS_DEFAULT_CURRENCY));
+		if (strlen(get_text_from_identifier(SETTINGS_DEFAULT_CURRENCY))==0) {
+			printf("Unable to get default currency value\n");
+			return 0;
+		}
+		sprintf(curr,"%s",settings_get_currency());
+	}
+	else {
+		sprintf((char*)curr,"%s",currency);
+	}
+
+	create_sqlite_database();
+
+	if (strlen(account)==0) {
+		printf("No account specified\n");
+		return 0;
+	}
+
+	create_sqlite_account(account);
+
+	database_name(account, (char*)database_filename);
+	retval = sqlite3_open_v2(database_filename,
+							 &handle,
+							 SQLITE_OPEN_READWRITE|SQLITE_OPEN_CREATE,
+							 NULL);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		return 0;
+	}
+
+	sprintf(lat,"%s",latitude);
+	if (strlen(latitude)==0) {
+		sprintf(lat,"%s","0");
+	}
+	sprintf(lng,"%s",longitude);
+	if (strlen(longitude)==0) {
+		sprintf(lng,"%s","0");
+	}
+	sprintf(alt,"%s",altitude);
+	if (strlen(altitude)==0) {
+		sprintf(alt,"%s","0");
+	}
+
+	if (strlen(timestr)>0) {
+		sprintf(datetime,"%s %s",date,timestr);
+	}
+	else {
+		sprintf(datetime,"%s",date);
+	}
+
+	sprintf((char*)query,
+			"INSERT INTO adjustments VALUES(" \
+			"\"%s\",\"%c\"," \
+			"\"%s\",\"%s\",%s,\"%s\",%s,%s,%d,\"%s\"," \
+			"\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\"," \
+			"\"%s\",\"%s\",%.3f,%s,%s,%s,\"%s\",\"%s\",%s);",
+			current_datetime, adjustment_type,
+			transaction_identifier,(char*)datetime,quantity,
+			description,spend,receive,recur,curr,status,
+			invoice_number,sales_number,purchase_number,
+			works_number,job_number,serial_number,
+			part_number,tracking_number,progress,
+			lat,lng,
+			alt,supplier,customer,VATrate);
+
+	retval = sqlite3_exec(handle,query,0,0,0);
+	if (retval) {
+		printf("Failed to insert record into adjustments table. " \
+			   "%s\n%s\n",sqlite3_errmsg(handle),
+			   query);
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	sqlite3_close(handle);
+	return 1;
+}
+
+int get_balance(
+				char * account,
+				char ** currency, char ** total_spent,
+				char ** total_received, char ** balance)
+{
+	int retval,col,cols;
+	char database_filename[STRING_BLOCK];
+	char query[] = "select currency, sum(spend) as totalspend," \
+		" sum(receive) as totalreceive, sum(receive-spend) as " \
+		"balance from transactions group by currency;";
+	int row=0;
+
+	/* A prepered statement for fetching tables */
+	sqlite3_stmt *stmt;
+    
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	if (account_exists(account)==0) {
+		return 0;
+	}
+    
+	/* if no account is specified use the default one */
+	if (strlen(account)==0) {
+		settings_set_account(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT));
+		if (strlen(get_text_from_identifier(SETTINGS_DEFAULT_CURRENT_ACCOUNT))==0) {
+			printf("Unable to get default account name\n");
+			return 0;
+		}
+		account = settings_get_account();
+	}
+
+	create_sqlite_database();
+
+	if (strlen(account)==0) {
+		printf("No account specified\n");
+		return 0;
+	}
+	database_name(account, (char*)database_filename);
+	retval = sqlite3_open_v2((char*)database_filename,
+							 &handle,
+							 SQLITE_OPEN_READWRITE|SQLITE_OPEN_CREATE,
+							 NULL);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	retval = sqlite3_prepare_v2(handle,query,-1,&stmt,0);
+	if(retval) {
+		printf("Unable to retrieve balance information. %s\n",
+			   sqlite3_errmsg(handle));
+		sqlite3_close(handle);
+		return 0;
+	}
+    
+	cols = sqlite3_column_count(stmt);
+
+	row = 0;
+	while(1) {
+		retval = sqlite3_step(stmt);
+        
+		if (retval == SQLITE_ROW) {
+			for(col=0; col < cols; col++) {
+				const char *val = (const char*)sqlite3_column_text(stmt,col);
+				if (col==0) {
+					sprintf((char*)&currency[row],"%s",val);
+				}
+				if (col==1) {
+					sprintf((char*)&total_spent[row],"%s",val);
+				}
+				if (col==2) {
+					sprintf((char*)&total_received[row],"%s",val);
+				}
+				if (col==3) {
+					sprintf((char*)&balance[row],"%s",val);
+				}
+			}
+			row++;
+			((char*)&total_spent[row])[0]=0;
+			((char*)&total_received[row])[0]=0;
+			((char*)&balance[row])[0]=0;
+			if (row>=9) break;
+		}
+		else if(retval == SQLITE_DONE) {
+			break;
+		}
+		else {
+			printf("Some error encountered while running balance query\n");
+			sqlite3_close(handle);
+			return 0;
+		}
+	}
+
+	retval = sqlite3_finalize(stmt);
+	if (retval != SQLITE_OK) {
+		printf("get_balance finalize error %d\n",retval);
+	}
+	sqlite3_close(handle);
+	return 1;
+}
+
+int clear_transaction_numbers()
+{
+	FILE * fp;
+	char filename[STRING_BLOCK];
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+
+	sprintf((char*)filename,"%s/transaction_numbers",directory);
+
+	fp = fopen(filename,"w");
+	if (fp!=0L) {
+		fclose(fp);
+	}
+
+	return 1;
+}
+
+int save_transaction_number(char * transaction_number)
+{
+	FILE * fp;
+	char filename[STRING_BLOCK];
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+
+	sprintf((char*)filename,"%s/transaction_numbers",directory);
+
+	fp = fopen(filename,"a");
+	if (fp!=0L) {
+		fprintf(fp,"%s\n",transaction_number);
+		fclose(fp);
+	}
+
+	return 1;
+}
+
+int get_transaction_number_from_record_number(int record_number,
+											  char * transaction_number)
+{
+	FILE * fp;
+	char filename[STRING_BLOCK];
+	char str[STRING_BLOCK];
+	int rec=1;
+	int found = 0;
+	char directory[STRING_BLOCK];
+
+	database_directory(directory);
+
+	transaction_number[0]=0;
+
+	sprintf((char*)filename,"%s/transaction_numbers",directory);
+
+	fp = fopen(filename,"r");
+	if (fp!=0L) {
+		while (!feof(fp)) {
+			if (fgets(str,64,fp) != NULL) {
+				if(rec==record_number) {
+					sprintf(transaction_number,"%s",str);
+					/* remove carriage return */
+					transaction_number[strlen(transaction_number)-1]=0;
+					found=1;
+					break;
+				}
+				rec++;
+			}
+		}
+		fclose(fp);
+	}
+	return found;
+}
+
+int database_edit_record(
+						 char * account,
+						 int record_number,
+						 char * prev_date, char * prev_timestr,
+						 char * prev_status, char * prev_description,
+						 char * prev_currency, char *prev_VATrate,
+						 float prev_progress, char * prev_supplier,
+						 char * prev_receive, char * prev_spend,
+						 char * date, char * timestr,
+						 char * status, char * description,
+						 char * currency, char *VATrate,
+						 float progress, char * supplier,
+						 char * receive, char * spend,
+						 char * date_format)
+{
+	int retval,tries,max_tries=4;
+	char database_filename[STRING_BLOCK];
+	char query[STRING_BLOCK];
+	char transaction_identifier[STRING_BLOCK];
+	char current_datetime[STRING_BLOCK];
+	char datetime[STRING_BLOCK];
+
+	/* Create a handle for database connection, create a pointer to sqlite3 */
+	sqlite3 *handle;
+
+	if (account_exists(account)==0) {
+		return 0;
+	}
+
+	/* get the transaction number */
+	if (get_transaction_number_from_record_number(record_number,
+												  (char*)transaction_identifier)==0) {
+		return 0;
+	}
+
+	if (strlen(timestr)>0) {
+		sprintf(datetime,"%s %s",date,timestr);
+	}
+	else {
+		sprintf(datetime,"%s",date);
+	}
+
+	sprintf((char*)query,
+			"update transactions set status=\"%s\"," \
+			"date=\"%s\"," \
+			"description=\"%s\",currency='%s'," \
+			"receive=%s,spend=%s,progress=%f where " \
+			"transaction_number = \"%s\"",
+			status,datetime,description,currency,receive,spend,
+			progress,transaction_identifier);
+
+	if (strlen(account)==0) {
+		printf("No account specified\n");
+		return 0;
+	}
+	database_name(account, (char*)database_filename);
+	retval = sqlite3_open((char*)database_filename,&handle);
+	/* If connection failed, handle returns NULL */
+	if (retval) {
+		printf("Sqlite3 database connection failed\n");
+		sqlite3_close(handle);
+		return 0;
+	}
+
+	tries=0;
+	while (tries<max_tries) {
+		retval = sqlite3_exec(handle,query,0,0,0);
+		if (retval == 5) {
+			fflush(stdout);
+			sleep(1);
+		}
+		else {
+			if (retval) {
+				printf("Unable to run edit query.  %s\n",
+					   sqlite3_errmsg(handle));
+				printf("%s\n",(char*)query);
+				sqlite3_close(handle);
+				return 0;
+			}
+			else {
+				break;
+			}
+		}
+		tries++;
+	}
+  
+	if (tries==max_tries) {
+		printf("%s\n",sqlite3_errmsg(handle));
+		printf("%s\n",(char*)query);
+		sqlite3_close(handle);
+		return 0;
+	}
+	sqlite3_close(handle);
+
+	/* save a corresponding adjustment */
+
+	/* ensure that the adjustments table exists */